From 4d711ebf4307b0821392ee62699ab1a4288566e1 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 714/1001] Convert the bugzilla widget


---

diff --git a/hubs/widgets/bugzilla/__init__.py b/hubs/widgets/bugzilla/__init__.py
new file mode 100644
index 0000000..ca42357
--- /dev/null
+++ b/hubs/widgets/bugzilla/__init__.py
@@ -0,0 +1,103 @@
+from __future__ import unicode_literals
+
+import requests
+import pkgwat.api
+
+from hubs import validators
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+
+PKGDB_URL = "https://admin.fedoraproject.org/pkgdb/api/packager/package"
+
+
+class Bugzilla(Widget):
+
+    name = "bugzilla"
+    position = "right"
+    arguments = [dict(
+        name="username",
+        label="Username",
+        default=None,
+        validator=validators.username,
+        help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/bugzilla.html"
+    chrome = panel("Bugzilla: Issues")
+
+    def get_context(self, instance, *args, **kwargs):
+        get_issues = GetIssues(instance)
+        return dict(
+            username=instance.config["username"],
+            issues=get_issues()
+            )
+
+
+class GetIssues(CachedFunction):
+
+    ''' Returns data for Bugzilla Widget. Queries pkgdb api for package
+    list of the user and bugzilla for correspoding issues '''
+
+    def execute(self):
+        username = self.instance.config["username"]
+        url = "/".join([PKGDB_URL, username])
+        response = requests.get(url)
+        data = response.json()
+
+        issues = []
+
+        # get the packages of which the user is
+        # point of contact
+        for package in data["point of contact"]:
+            if len(issues) == 3:
+                break
+            pkg_details = pkgwat.api.bugs(package['name'])
+            for row in pkg_details['rows']:
+                if len(issues) == 3:
+                    break
+                issues.append(
+                    dict(
+                        id=row['id'],
+                        title=row['description'],
+                        pkg_name=package['name'],
+                    )
+                )
+
+        # get the packages of which the user is
+        # co maintainer
+        for package in data["co-maintained"]:
+            if len(issues) == 3:
+                break
+            pkg_details = pkgwat.api.bugs(package['name'])
+            for row in pkg_details['rows']:
+                if len(issues) == 3:
+                    break
+                issues.append(
+                    dict(
+                        id=row['id'],
+                        title=row['description'],
+                        pkg_name=package['name'],
+                    )
+                )
+
+        return issues
+
+    def should_invalidate(self, message):
+        username = self.instance.config["username"]
+        url = "/".join([PKGDB_URL, username])
+        response = requests.get(url)
+        data = response.json()
+
+        owned = data['point of contact'] + data['co-maintained']
+        owned = [p['name'] for p in owned]
+        if message['msg']['bug']['component'] in owned:
+            return True
+
+        return False

